package com.hfkj.entity;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class GoodsLogisticsExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private Integer limit;

    private Long offset;

    public GoodsLogisticsExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    public void setLimit(Integer limit) {
        this.limit = limit;
    }

    public Integer getLimit() {
        return limit;
    }

    public void setOffset(Long offset) {
        this.offset = offset;
    }

    public Long getOffset() {
        return offset;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andUserIdIsNull() {
            addCriterion("user_id is null");
            return (Criteria) this;
        }

        public Criteria andUserIdIsNotNull() {
            addCriterion("user_id is not null");
            return (Criteria) this;
        }

        public Criteria andUserIdEqualTo(Long value) {
            addCriterion("user_id =", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotEqualTo(Long value) {
            addCriterion("user_id <>", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdGreaterThan(Long value) {
            addCriterion("user_id >", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdGreaterThanOrEqualTo(Long value) {
            addCriterion("user_id >=", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdLessThan(Long value) {
            addCriterion("user_id <", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdLessThanOrEqualTo(Long value) {
            addCriterion("user_id <=", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdIn(List<Long> values) {
            addCriterion("user_id in", values, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotIn(List<Long> values) {
            addCriterion("user_id not in", values, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdBetween(Long value1, Long value2) {
            addCriterion("user_id between", value1, value2, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotBetween(Long value1, Long value2) {
            addCriterion("user_id not between", value1, value2, "userId");
            return (Criteria) this;
        }

        public Criteria andOrderIdIsNull() {
            addCriterion("order_id is null");
            return (Criteria) this;
        }

        public Criteria andOrderIdIsNotNull() {
            addCriterion("order_id is not null");
            return (Criteria) this;
        }

        public Criteria andOrderIdEqualTo(Long value) {
            addCriterion("order_id =", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdNotEqualTo(Long value) {
            addCriterion("order_id <>", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdGreaterThan(Long value) {
            addCriterion("order_id >", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdGreaterThanOrEqualTo(Long value) {
            addCriterion("order_id >=", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdLessThan(Long value) {
            addCriterion("order_id <", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdLessThanOrEqualTo(Long value) {
            addCriterion("order_id <=", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdIn(List<Long> values) {
            addCriterion("order_id in", values, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdNotIn(List<Long> values) {
            addCriterion("order_id not in", values, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdBetween(Long value1, Long value2) {
            addCriterion("order_id between", value1, value2, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdNotBetween(Long value1, Long value2) {
            addCriterion("order_id not between", value1, value2, "orderId");
            return (Criteria) this;
        }

        public Criteria andTaskNoIsNull() {
            addCriterion("task_no is null");
            return (Criteria) this;
        }

        public Criteria andTaskNoIsNotNull() {
            addCriterion("task_no is not null");
            return (Criteria) this;
        }

        public Criteria andTaskNoEqualTo(String value) {
            addCriterion("task_no =", value, "taskNo");
            return (Criteria) this;
        }

        public Criteria andTaskNoNotEqualTo(String value) {
            addCriterion("task_no <>", value, "taskNo");
            return (Criteria) this;
        }

        public Criteria andTaskNoGreaterThan(String value) {
            addCriterion("task_no >", value, "taskNo");
            return (Criteria) this;
        }

        public Criteria andTaskNoGreaterThanOrEqualTo(String value) {
            addCriterion("task_no >=", value, "taskNo");
            return (Criteria) this;
        }

        public Criteria andTaskNoLessThan(String value) {
            addCriterion("task_no <", value, "taskNo");
            return (Criteria) this;
        }

        public Criteria andTaskNoLessThanOrEqualTo(String value) {
            addCriterion("task_no <=", value, "taskNo");
            return (Criteria) this;
        }

        public Criteria andTaskNoLike(String value) {
            addCriterion("task_no like", value, "taskNo");
            return (Criteria) this;
        }

        public Criteria andTaskNoNotLike(String value) {
            addCriterion("task_no not like", value, "taskNo");
            return (Criteria) this;
        }

        public Criteria andTaskNoIn(List<String> values) {
            addCriterion("task_no in", values, "taskNo");
            return (Criteria) this;
        }

        public Criteria andTaskNoNotIn(List<String> values) {
            addCriterion("task_no not in", values, "taskNo");
            return (Criteria) this;
        }

        public Criteria andTaskNoBetween(String value1, String value2) {
            addCriterion("task_no between", value1, value2, "taskNo");
            return (Criteria) this;
        }

        public Criteria andTaskNoNotBetween(String value1, String value2) {
            addCriterion("task_no not between", value1, value2, "taskNo");
            return (Criteria) this;
        }

        public Criteria andNumberIsNull() {
            addCriterion("`number` is null");
            return (Criteria) this;
        }

        public Criteria andNumberIsNotNull() {
            addCriterion("`number` is not null");
            return (Criteria) this;
        }

        public Criteria andNumberEqualTo(String value) {
            addCriterion("`number` =", value, "number");
            return (Criteria) this;
        }

        public Criteria andNumberNotEqualTo(String value) {
            addCriterion("`number` <>", value, "number");
            return (Criteria) this;
        }

        public Criteria andNumberGreaterThan(String value) {
            addCriterion("`number` >", value, "number");
            return (Criteria) this;
        }

        public Criteria andNumberGreaterThanOrEqualTo(String value) {
            addCriterion("`number` >=", value, "number");
            return (Criteria) this;
        }

        public Criteria andNumberLessThan(String value) {
            addCriterion("`number` <", value, "number");
            return (Criteria) this;
        }

        public Criteria andNumberLessThanOrEqualTo(String value) {
            addCriterion("`number` <=", value, "number");
            return (Criteria) this;
        }

        public Criteria andNumberLike(String value) {
            addCriterion("`number` like", value, "number");
            return (Criteria) this;
        }

        public Criteria andNumberNotLike(String value) {
            addCriterion("`number` not like", value, "number");
            return (Criteria) this;
        }

        public Criteria andNumberIn(List<String> values) {
            addCriterion("`number` in", values, "number");
            return (Criteria) this;
        }

        public Criteria andNumberNotIn(List<String> values) {
            addCriterion("`number` not in", values, "number");
            return (Criteria) this;
        }

        public Criteria andNumberBetween(String value1, String value2) {
            addCriterion("`number` between", value1, value2, "number");
            return (Criteria) this;
        }

        public Criteria andNumberNotBetween(String value1, String value2) {
            addCriterion("`number` not between", value1, value2, "number");
            return (Criteria) this;
        }

        public Criteria andLogisticsStatusIsNull() {
            addCriterion("logistics_status is null");
            return (Criteria) this;
        }

        public Criteria andLogisticsStatusIsNotNull() {
            addCriterion("logistics_status is not null");
            return (Criteria) this;
        }

        public Criteria andLogisticsStatusEqualTo(String value) {
            addCriterion("logistics_status =", value, "logisticsStatus");
            return (Criteria) this;
        }

        public Criteria andLogisticsStatusNotEqualTo(String value) {
            addCriterion("logistics_status <>", value, "logisticsStatus");
            return (Criteria) this;
        }

        public Criteria andLogisticsStatusGreaterThan(String value) {
            addCriterion("logistics_status >", value, "logisticsStatus");
            return (Criteria) this;
        }

        public Criteria andLogisticsStatusGreaterThanOrEqualTo(String value) {
            addCriterion("logistics_status >=", value, "logisticsStatus");
            return (Criteria) this;
        }

        public Criteria andLogisticsStatusLessThan(String value) {
            addCriterion("logistics_status <", value, "logisticsStatus");
            return (Criteria) this;
        }

        public Criteria andLogisticsStatusLessThanOrEqualTo(String value) {
            addCriterion("logistics_status <=", value, "logisticsStatus");
            return (Criteria) this;
        }

        public Criteria andLogisticsStatusLike(String value) {
            addCriterion("logistics_status like", value, "logisticsStatus");
            return (Criteria) this;
        }

        public Criteria andLogisticsStatusNotLike(String value) {
            addCriterion("logistics_status not like", value, "logisticsStatus");
            return (Criteria) this;
        }

        public Criteria andLogisticsStatusIn(List<String> values) {
            addCriterion("logistics_status in", values, "logisticsStatus");
            return (Criteria) this;
        }

        public Criteria andLogisticsStatusNotIn(List<String> values) {
            addCriterion("logistics_status not in", values, "logisticsStatus");
            return (Criteria) this;
        }

        public Criteria andLogisticsStatusBetween(String value1, String value2) {
            addCriterion("logistics_status between", value1, value2, "logisticsStatus");
            return (Criteria) this;
        }

        public Criteria andLogisticsStatusNotBetween(String value1, String value2) {
            addCriterion("logistics_status not between", value1, value2, "logisticsStatus");
            return (Criteria) this;
        }

        public Criteria andLogisticsStatusDescIsNull() {
            addCriterion("logistics_status_desc is null");
            return (Criteria) this;
        }

        public Criteria andLogisticsStatusDescIsNotNull() {
            addCriterion("logistics_status_desc is not null");
            return (Criteria) this;
        }

        public Criteria andLogisticsStatusDescEqualTo(String value) {
            addCriterion("logistics_status_desc =", value, "logisticsStatusDesc");
            return (Criteria) this;
        }

        public Criteria andLogisticsStatusDescNotEqualTo(String value) {
            addCriterion("logistics_status_desc <>", value, "logisticsStatusDesc");
            return (Criteria) this;
        }

        public Criteria andLogisticsStatusDescGreaterThan(String value) {
            addCriterion("logistics_status_desc >", value, "logisticsStatusDesc");
            return (Criteria) this;
        }

        public Criteria andLogisticsStatusDescGreaterThanOrEqualTo(String value) {
            addCriterion("logistics_status_desc >=", value, "logisticsStatusDesc");
            return (Criteria) this;
        }

        public Criteria andLogisticsStatusDescLessThan(String value) {
            addCriterion("logistics_status_desc <", value, "logisticsStatusDesc");
            return (Criteria) this;
        }

        public Criteria andLogisticsStatusDescLessThanOrEqualTo(String value) {
            addCriterion("logistics_status_desc <=", value, "logisticsStatusDesc");
            return (Criteria) this;
        }

        public Criteria andLogisticsStatusDescLike(String value) {
            addCriterion("logistics_status_desc like", value, "logisticsStatusDesc");
            return (Criteria) this;
        }

        public Criteria andLogisticsStatusDescNotLike(String value) {
            addCriterion("logistics_status_desc not like", value, "logisticsStatusDesc");
            return (Criteria) this;
        }

        public Criteria andLogisticsStatusDescIn(List<String> values) {
            addCriterion("logistics_status_desc in", values, "logisticsStatusDesc");
            return (Criteria) this;
        }

        public Criteria andLogisticsStatusDescNotIn(List<String> values) {
            addCriterion("logistics_status_desc not in", values, "logisticsStatusDesc");
            return (Criteria) this;
        }

        public Criteria andLogisticsStatusDescBetween(String value1, String value2) {
            addCriterion("logistics_status_desc between", value1, value2, "logisticsStatusDesc");
            return (Criteria) this;
        }

        public Criteria andLogisticsStatusDescNotBetween(String value1, String value2) {
            addCriterion("logistics_status_desc not between", value1, value2, "logisticsStatusDesc");
            return (Criteria) this;
        }

        public Criteria andTheLastMessageIsNull() {
            addCriterion("the_last_message is null");
            return (Criteria) this;
        }

        public Criteria andTheLastMessageIsNotNull() {
            addCriterion("the_last_message is not null");
            return (Criteria) this;
        }

        public Criteria andTheLastMessageEqualTo(String value) {
            addCriterion("the_last_message =", value, "theLastMessage");
            return (Criteria) this;
        }

        public Criteria andTheLastMessageNotEqualTo(String value) {
            addCriterion("the_last_message <>", value, "theLastMessage");
            return (Criteria) this;
        }

        public Criteria andTheLastMessageGreaterThan(String value) {
            addCriterion("the_last_message >", value, "theLastMessage");
            return (Criteria) this;
        }

        public Criteria andTheLastMessageGreaterThanOrEqualTo(String value) {
            addCriterion("the_last_message >=", value, "theLastMessage");
            return (Criteria) this;
        }

        public Criteria andTheLastMessageLessThan(String value) {
            addCriterion("the_last_message <", value, "theLastMessage");
            return (Criteria) this;
        }

        public Criteria andTheLastMessageLessThanOrEqualTo(String value) {
            addCriterion("the_last_message <=", value, "theLastMessage");
            return (Criteria) this;
        }

        public Criteria andTheLastMessageLike(String value) {
            addCriterion("the_last_message like", value, "theLastMessage");
            return (Criteria) this;
        }

        public Criteria andTheLastMessageNotLike(String value) {
            addCriterion("the_last_message not like", value, "theLastMessage");
            return (Criteria) this;
        }

        public Criteria andTheLastMessageIn(List<String> values) {
            addCriterion("the_last_message in", values, "theLastMessage");
            return (Criteria) this;
        }

        public Criteria andTheLastMessageNotIn(List<String> values) {
            addCriterion("the_last_message not in", values, "theLastMessage");
            return (Criteria) this;
        }

        public Criteria andTheLastMessageBetween(String value1, String value2) {
            addCriterion("the_last_message between", value1, value2, "theLastMessage");
            return (Criteria) this;
        }

        public Criteria andTheLastMessageNotBetween(String value1, String value2) {
            addCriterion("the_last_message not between", value1, value2, "theLastMessage");
            return (Criteria) this;
        }

        public Criteria andTheLastTimeIsNull() {
            addCriterion("the_last_time is null");
            return (Criteria) this;
        }

        public Criteria andTheLastTimeIsNotNull() {
            addCriterion("the_last_time is not null");
            return (Criteria) this;
        }

        public Criteria andTheLastTimeEqualTo(Date value) {
            addCriterion("the_last_time =", value, "theLastTime");
            return (Criteria) this;
        }

        public Criteria andTheLastTimeNotEqualTo(Date value) {
            addCriterion("the_last_time <>", value, "theLastTime");
            return (Criteria) this;
        }

        public Criteria andTheLastTimeGreaterThan(Date value) {
            addCriterion("the_last_time >", value, "theLastTime");
            return (Criteria) this;
        }

        public Criteria andTheLastTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("the_last_time >=", value, "theLastTime");
            return (Criteria) this;
        }

        public Criteria andTheLastTimeLessThan(Date value) {
            addCriterion("the_last_time <", value, "theLastTime");
            return (Criteria) this;
        }

        public Criteria andTheLastTimeLessThanOrEqualTo(Date value) {
            addCriterion("the_last_time <=", value, "theLastTime");
            return (Criteria) this;
        }

        public Criteria andTheLastTimeIn(List<Date> values) {
            addCriterion("the_last_time in", values, "theLastTime");
            return (Criteria) this;
        }

        public Criteria andTheLastTimeNotIn(List<Date> values) {
            addCriterion("the_last_time not in", values, "theLastTime");
            return (Criteria) this;
        }

        public Criteria andTheLastTimeBetween(Date value1, Date value2) {
            addCriterion("the_last_time between", value1, value2, "theLastTime");
            return (Criteria) this;
        }

        public Criteria andTheLastTimeNotBetween(Date value1, Date value2) {
            addCriterion("the_last_time not between", value1, value2, "theLastTime");
            return (Criteria) this;
        }

        public Criteria andTakeTimeIsNull() {
            addCriterion("take_time is null");
            return (Criteria) this;
        }

        public Criteria andTakeTimeIsNotNull() {
            addCriterion("take_time is not null");
            return (Criteria) this;
        }

        public Criteria andTakeTimeEqualTo(String value) {
            addCriterion("take_time =", value, "takeTime");
            return (Criteria) this;
        }

        public Criteria andTakeTimeNotEqualTo(String value) {
            addCriterion("take_time <>", value, "takeTime");
            return (Criteria) this;
        }

        public Criteria andTakeTimeGreaterThan(String value) {
            addCriterion("take_time >", value, "takeTime");
            return (Criteria) this;
        }

        public Criteria andTakeTimeGreaterThanOrEqualTo(String value) {
            addCriterion("take_time >=", value, "takeTime");
            return (Criteria) this;
        }

        public Criteria andTakeTimeLessThan(String value) {
            addCriterion("take_time <", value, "takeTime");
            return (Criteria) this;
        }

        public Criteria andTakeTimeLessThanOrEqualTo(String value) {
            addCriterion("take_time <=", value, "takeTime");
            return (Criteria) this;
        }

        public Criteria andTakeTimeLike(String value) {
            addCriterion("take_time like", value, "takeTime");
            return (Criteria) this;
        }

        public Criteria andTakeTimeNotLike(String value) {
            addCriterion("take_time not like", value, "takeTime");
            return (Criteria) this;
        }

        public Criteria andTakeTimeIn(List<String> values) {
            addCriterion("take_time in", values, "takeTime");
            return (Criteria) this;
        }

        public Criteria andTakeTimeNotIn(List<String> values) {
            addCriterion("take_time not in", values, "takeTime");
            return (Criteria) this;
        }

        public Criteria andTakeTimeBetween(String value1, String value2) {
            addCriterion("take_time between", value1, value2, "takeTime");
            return (Criteria) this;
        }

        public Criteria andTakeTimeNotBetween(String value1, String value2) {
            addCriterion("take_time not between", value1, value2, "takeTime");
            return (Criteria) this;
        }

        public Criteria andCourierIsNull() {
            addCriterion("courier is null");
            return (Criteria) this;
        }

        public Criteria andCourierIsNotNull() {
            addCriterion("courier is not null");
            return (Criteria) this;
        }

        public Criteria andCourierEqualTo(String value) {
            addCriterion("courier =", value, "courier");
            return (Criteria) this;
        }

        public Criteria andCourierNotEqualTo(String value) {
            addCriterion("courier <>", value, "courier");
            return (Criteria) this;
        }

        public Criteria andCourierGreaterThan(String value) {
            addCriterion("courier >", value, "courier");
            return (Criteria) this;
        }

        public Criteria andCourierGreaterThanOrEqualTo(String value) {
            addCriterion("courier >=", value, "courier");
            return (Criteria) this;
        }

        public Criteria andCourierLessThan(String value) {
            addCriterion("courier <", value, "courier");
            return (Criteria) this;
        }

        public Criteria andCourierLessThanOrEqualTo(String value) {
            addCriterion("courier <=", value, "courier");
            return (Criteria) this;
        }

        public Criteria andCourierLike(String value) {
            addCriterion("courier like", value, "courier");
            return (Criteria) this;
        }

        public Criteria andCourierNotLike(String value) {
            addCriterion("courier not like", value, "courier");
            return (Criteria) this;
        }

        public Criteria andCourierIn(List<String> values) {
            addCriterion("courier in", values, "courier");
            return (Criteria) this;
        }

        public Criteria andCourierNotIn(List<String> values) {
            addCriterion("courier not in", values, "courier");
            return (Criteria) this;
        }

        public Criteria andCourierBetween(String value1, String value2) {
            addCriterion("courier between", value1, value2, "courier");
            return (Criteria) this;
        }

        public Criteria andCourierNotBetween(String value1, String value2) {
            addCriterion("courier not between", value1, value2, "courier");
            return (Criteria) this;
        }

        public Criteria andCourierPhoneIsNull() {
            addCriterion("courier_phone is null");
            return (Criteria) this;
        }

        public Criteria andCourierPhoneIsNotNull() {
            addCriterion("courier_phone is not null");
            return (Criteria) this;
        }

        public Criteria andCourierPhoneEqualTo(String value) {
            addCriterion("courier_phone =", value, "courierPhone");
            return (Criteria) this;
        }

        public Criteria andCourierPhoneNotEqualTo(String value) {
            addCriterion("courier_phone <>", value, "courierPhone");
            return (Criteria) this;
        }

        public Criteria andCourierPhoneGreaterThan(String value) {
            addCriterion("courier_phone >", value, "courierPhone");
            return (Criteria) this;
        }

        public Criteria andCourierPhoneGreaterThanOrEqualTo(String value) {
            addCriterion("courier_phone >=", value, "courierPhone");
            return (Criteria) this;
        }

        public Criteria andCourierPhoneLessThan(String value) {
            addCriterion("courier_phone <", value, "courierPhone");
            return (Criteria) this;
        }

        public Criteria andCourierPhoneLessThanOrEqualTo(String value) {
            addCriterion("courier_phone <=", value, "courierPhone");
            return (Criteria) this;
        }

        public Criteria andCourierPhoneLike(String value) {
            addCriterion("courier_phone like", value, "courierPhone");
            return (Criteria) this;
        }

        public Criteria andCourierPhoneNotLike(String value) {
            addCriterion("courier_phone not like", value, "courierPhone");
            return (Criteria) this;
        }

        public Criteria andCourierPhoneIn(List<String> values) {
            addCriterion("courier_phone in", values, "courierPhone");
            return (Criteria) this;
        }

        public Criteria andCourierPhoneNotIn(List<String> values) {
            addCriterion("courier_phone not in", values, "courierPhone");
            return (Criteria) this;
        }

        public Criteria andCourierPhoneBetween(String value1, String value2) {
            addCriterion("courier_phone between", value1, value2, "courierPhone");
            return (Criteria) this;
        }

        public Criteria andCourierPhoneNotBetween(String value1, String value2) {
            addCriterion("courier_phone not between", value1, value2, "courierPhone");
            return (Criteria) this;
        }

        public Criteria andLogisticsTraceDetailsIsNull() {
            addCriterion("logistics_trace_details is null");
            return (Criteria) this;
        }

        public Criteria andLogisticsTraceDetailsIsNotNull() {
            addCriterion("logistics_trace_details is not null");
            return (Criteria) this;
        }

        public Criteria andLogisticsTraceDetailsEqualTo(String value) {
            addCriterion("logistics_trace_details =", value, "logisticsTraceDetails");
            return (Criteria) this;
        }

        public Criteria andLogisticsTraceDetailsNotEqualTo(String value) {
            addCriterion("logistics_trace_details <>", value, "logisticsTraceDetails");
            return (Criteria) this;
        }

        public Criteria andLogisticsTraceDetailsGreaterThan(String value) {
            addCriterion("logistics_trace_details >", value, "logisticsTraceDetails");
            return (Criteria) this;
        }

        public Criteria andLogisticsTraceDetailsGreaterThanOrEqualTo(String value) {
            addCriterion("logistics_trace_details >=", value, "logisticsTraceDetails");
            return (Criteria) this;
        }

        public Criteria andLogisticsTraceDetailsLessThan(String value) {
            addCriterion("logistics_trace_details <", value, "logisticsTraceDetails");
            return (Criteria) this;
        }

        public Criteria andLogisticsTraceDetailsLessThanOrEqualTo(String value) {
            addCriterion("logistics_trace_details <=", value, "logisticsTraceDetails");
            return (Criteria) this;
        }

        public Criteria andLogisticsTraceDetailsLike(String value) {
            addCriterion("logistics_trace_details like", value, "logisticsTraceDetails");
            return (Criteria) this;
        }

        public Criteria andLogisticsTraceDetailsNotLike(String value) {
            addCriterion("logistics_trace_details not like", value, "logisticsTraceDetails");
            return (Criteria) this;
        }

        public Criteria andLogisticsTraceDetailsIn(List<String> values) {
            addCriterion("logistics_trace_details in", values, "logisticsTraceDetails");
            return (Criteria) this;
        }

        public Criteria andLogisticsTraceDetailsNotIn(List<String> values) {
            addCriterion("logistics_trace_details not in", values, "logisticsTraceDetails");
            return (Criteria) this;
        }

        public Criteria andLogisticsTraceDetailsBetween(String value1, String value2) {
            addCriterion("logistics_trace_details between", value1, value2, "logisticsTraceDetails");
            return (Criteria) this;
        }

        public Criteria andLogisticsTraceDetailsNotBetween(String value1, String value2) {
            addCriterion("logistics_trace_details not between", value1, value2, "logisticsTraceDetails");
            return (Criteria) this;
        }

        public Criteria andExpressCompanyNameIsNull() {
            addCriterion("express_company_name is null");
            return (Criteria) this;
        }

        public Criteria andExpressCompanyNameIsNotNull() {
            addCriterion("express_company_name is not null");
            return (Criteria) this;
        }

        public Criteria andExpressCompanyNameEqualTo(String value) {
            addCriterion("express_company_name =", value, "expressCompanyName");
            return (Criteria) this;
        }

        public Criteria andExpressCompanyNameNotEqualTo(String value) {
            addCriterion("express_company_name <>", value, "expressCompanyName");
            return (Criteria) this;
        }

        public Criteria andExpressCompanyNameGreaterThan(String value) {
            addCriterion("express_company_name >", value, "expressCompanyName");
            return (Criteria) this;
        }

        public Criteria andExpressCompanyNameGreaterThanOrEqualTo(String value) {
            addCriterion("express_company_name >=", value, "expressCompanyName");
            return (Criteria) this;
        }

        public Criteria andExpressCompanyNameLessThan(String value) {
            addCriterion("express_company_name <", value, "expressCompanyName");
            return (Criteria) this;
        }

        public Criteria andExpressCompanyNameLessThanOrEqualTo(String value) {
            addCriterion("express_company_name <=", value, "expressCompanyName");
            return (Criteria) this;
        }

        public Criteria andExpressCompanyNameLike(String value) {
            addCriterion("express_company_name like", value, "expressCompanyName");
            return (Criteria) this;
        }

        public Criteria andExpressCompanyNameNotLike(String value) {
            addCriterion("express_company_name not like", value, "expressCompanyName");
            return (Criteria) this;
        }

        public Criteria andExpressCompanyNameIn(List<String> values) {
            addCriterion("express_company_name in", values, "expressCompanyName");
            return (Criteria) this;
        }

        public Criteria andExpressCompanyNameNotIn(List<String> values) {
            addCriterion("express_company_name not in", values, "expressCompanyName");
            return (Criteria) this;
        }

        public Criteria andExpressCompanyNameBetween(String value1, String value2) {
            addCriterion("express_company_name between", value1, value2, "expressCompanyName");
            return (Criteria) this;
        }

        public Criteria andExpressCompanyNameNotBetween(String value1, String value2) {
            addCriterion("express_company_name not between", value1, value2, "expressCompanyName");
            return (Criteria) this;
        }

        public Criteria andStatusIsNull() {
            addCriterion("`status` is null");
            return (Criteria) this;
        }

        public Criteria andStatusIsNotNull() {
            addCriterion("`status` is not null");
            return (Criteria) this;
        }

        public Criteria andStatusEqualTo(Integer value) {
            addCriterion("`status` =", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotEqualTo(Integer value) {
            addCriterion("`status` <>", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThan(Integer value) {
            addCriterion("`status` >", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("`status` >=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThan(Integer value) {
            addCriterion("`status` <", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThanOrEqualTo(Integer value) {
            addCriterion("`status` <=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusIn(List<Integer> values) {
            addCriterion("`status` in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotIn(List<Integer> values) {
            addCriterion("`status` not in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusBetween(Integer value1, Integer value2) {
            addCriterion("`status` between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("`status` not between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andOpIdIsNull() {
            addCriterion("op_id is null");
            return (Criteria) this;
        }

        public Criteria andOpIdIsNotNull() {
            addCriterion("op_id is not null");
            return (Criteria) this;
        }

        public Criteria andOpIdEqualTo(Long value) {
            addCriterion("op_id =", value, "opId");
            return (Criteria) this;
        }

        public Criteria andOpIdNotEqualTo(Long value) {
            addCriterion("op_id <>", value, "opId");
            return (Criteria) this;
        }

        public Criteria andOpIdGreaterThan(Long value) {
            addCriterion("op_id >", value, "opId");
            return (Criteria) this;
        }

        public Criteria andOpIdGreaterThanOrEqualTo(Long value) {
            addCriterion("op_id >=", value, "opId");
            return (Criteria) this;
        }

        public Criteria andOpIdLessThan(Long value) {
            addCriterion("op_id <", value, "opId");
            return (Criteria) this;
        }

        public Criteria andOpIdLessThanOrEqualTo(Long value) {
            addCriterion("op_id <=", value, "opId");
            return (Criteria) this;
        }

        public Criteria andOpIdIn(List<Long> values) {
            addCriterion("op_id in", values, "opId");
            return (Criteria) this;
        }

        public Criteria andOpIdNotIn(List<Long> values) {
            addCriterion("op_id not in", values, "opId");
            return (Criteria) this;
        }

        public Criteria andOpIdBetween(Long value1, Long value2) {
            addCriterion("op_id between", value1, value2, "opId");
            return (Criteria) this;
        }

        public Criteria andOpIdNotBetween(Long value1, Long value2) {
            addCriterion("op_id not between", value1, value2, "opId");
            return (Criteria) this;
        }

        public Criteria andOpNameIsNull() {
            addCriterion("op_name is null");
            return (Criteria) this;
        }

        public Criteria andOpNameIsNotNull() {
            addCriterion("op_name is not null");
            return (Criteria) this;
        }

        public Criteria andOpNameEqualTo(String value) {
            addCriterion("op_name =", value, "opName");
            return (Criteria) this;
        }

        public Criteria andOpNameNotEqualTo(String value) {
            addCriterion("op_name <>", value, "opName");
            return (Criteria) this;
        }

        public Criteria andOpNameGreaterThan(String value) {
            addCriterion("op_name >", value, "opName");
            return (Criteria) this;
        }

        public Criteria andOpNameGreaterThanOrEqualTo(String value) {
            addCriterion("op_name >=", value, "opName");
            return (Criteria) this;
        }

        public Criteria andOpNameLessThan(String value) {
            addCriterion("op_name <", value, "opName");
            return (Criteria) this;
        }

        public Criteria andOpNameLessThanOrEqualTo(String value) {
            addCriterion("op_name <=", value, "opName");
            return (Criteria) this;
        }

        public Criteria andOpNameLike(String value) {
            addCriterion("op_name like", value, "opName");
            return (Criteria) this;
        }

        public Criteria andOpNameNotLike(String value) {
            addCriterion("op_name not like", value, "opName");
            return (Criteria) this;
        }

        public Criteria andOpNameIn(List<String> values) {
            addCriterion("op_name in", values, "opName");
            return (Criteria) this;
        }

        public Criteria andOpNameNotIn(List<String> values) {
            addCriterion("op_name not in", values, "opName");
            return (Criteria) this;
        }

        public Criteria andOpNameBetween(String value1, String value2) {
            addCriterion("op_name between", value1, value2, "opName");
            return (Criteria) this;
        }

        public Criteria andOpNameNotBetween(String value1, String value2) {
            addCriterion("op_name not between", value1, value2, "opName");
            return (Criteria) this;
        }

        public Criteria andExt1IsNull() {
            addCriterion("ext_1 is null");
            return (Criteria) this;
        }

        public Criteria andExt1IsNotNull() {
            addCriterion("ext_1 is not null");
            return (Criteria) this;
        }

        public Criteria andExt1EqualTo(String value) {
            addCriterion("ext_1 =", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotEqualTo(String value) {
            addCriterion("ext_1 <>", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThan(String value) {
            addCriterion("ext_1 >", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThanOrEqualTo(String value) {
            addCriterion("ext_1 >=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThan(String value) {
            addCriterion("ext_1 <", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThanOrEqualTo(String value) {
            addCriterion("ext_1 <=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Like(String value) {
            addCriterion("ext_1 like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotLike(String value) {
            addCriterion("ext_1 not like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1In(List<String> values) {
            addCriterion("ext_1 in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotIn(List<String> values) {
            addCriterion("ext_1 not in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Between(String value1, String value2) {
            addCriterion("ext_1 between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotBetween(String value1, String value2) {
            addCriterion("ext_1 not between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt2IsNull() {
            addCriterion("ext_2 is null");
            return (Criteria) this;
        }

        public Criteria andExt2IsNotNull() {
            addCriterion("ext_2 is not null");
            return (Criteria) this;
        }

        public Criteria andExt2EqualTo(String value) {
            addCriterion("ext_2 =", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotEqualTo(String value) {
            addCriterion("ext_2 <>", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThan(String value) {
            addCriterion("ext_2 >", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThanOrEqualTo(String value) {
            addCriterion("ext_2 >=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThan(String value) {
            addCriterion("ext_2 <", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThanOrEqualTo(String value) {
            addCriterion("ext_2 <=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Like(String value) {
            addCriterion("ext_2 like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotLike(String value) {
            addCriterion("ext_2 not like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2In(List<String> values) {
            addCriterion("ext_2 in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotIn(List<String> values) {
            addCriterion("ext_2 not in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Between(String value1, String value2) {
            addCriterion("ext_2 between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotBetween(String value1, String value2) {
            addCriterion("ext_2 not between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt3IsNull() {
            addCriterion("ext_3 is null");
            return (Criteria) this;
        }

        public Criteria andExt3IsNotNull() {
            addCriterion("ext_3 is not null");
            return (Criteria) this;
        }

        public Criteria andExt3EqualTo(String value) {
            addCriterion("ext_3 =", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotEqualTo(String value) {
            addCriterion("ext_3 <>", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThan(String value) {
            addCriterion("ext_3 >", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThanOrEqualTo(String value) {
            addCriterion("ext_3 >=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThan(String value) {
            addCriterion("ext_3 <", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThanOrEqualTo(String value) {
            addCriterion("ext_3 <=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Like(String value) {
            addCriterion("ext_3 like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotLike(String value) {
            addCriterion("ext_3 not like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3In(List<String> values) {
            addCriterion("ext_3 in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotIn(List<String> values) {
            addCriterion("ext_3 not in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Between(String value1, String value2) {
            addCriterion("ext_3 between", value1, value2, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotBetween(String value1, String value2) {
            addCriterion("ext_3 not between", value1, value2, "ext3");
            return (Criteria) this;
        }
    }

    /**
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}